local frame = CreateFrame("FRAME")
LibStub("AceTimer-3.0"):Embed(frame)
local state = true

frame:RegisterEvent("CHAT_MSG_SYSTEM")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")

frame:SetScript("OnEvent", function(self, event, ...)
	return self[event](self, event, ...)
end)

function frame:CHAT_MSG_SYSTEM(event, msg)
	if state and msg == TRANSFER_ABORT_TOO_MANY_REALM_INSTANCES then
		self:ScheduleTimer("RetryTeleport", AUTODUNGEONRETRY_DELAY)
		print("|cff33ff99AutoDungeonRetry:|r", string.format("Retrying instance teleport in %d seconds.", AUTODUNGEONRETRY_DELAY))
	end
end

function frame:PLAYER_ENTERING_WORLD()
	AUTODUNGEONRETRY_DELAY = AUTODUNGEONRETRY_DELAY or 5
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
end

function frame:RetryTeleport()
	return LFGTeleport()
end

--slashy slashy
_G["SlashCmdList"]["AUTODUNGEONRETRY_MAIN"] = function(s)
	local num = tonumber(s)
	if num then
		AUTODUNGEONRETRY_DELAY = num
		print("|cff33ff99AutoDungeonRetry:|r", "Setting delay to:", num)
	else
		state = not state
		print("|cff33ff99AutoDungeonRetry:|r", state and "Enabled" or "Disabled")
	end
end
_G["SLASH_AUTODUNGEONRETRY_MAIN1"] = "/adr"
_G["SLASH_AUTODUNGEONRETRY_MAIN2"] = "/autoretry"
